%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    Copyright (C) 2004 Adam Spiro and Aharon Bar-Hillel
%    An implementation of a spike sorting algorithm according to the paper:
%    "Spike Sorting: Bayesian Clustering of Non-Stationary Data" 
%    by Aharon Bar-Hillel, Adam Spiro and Eran Stark 
%    (http://www.cs.huji.ac.il/~aharonbh/papers/SpikeSort_NIPS04.ps)
%
%    This program is free software; you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation; either version 2 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [pLabels, pCorr, pBiMixScores,pRecordGraph, pSolutions,ppath,pLL] = ...
            post2(data,PSolutions,N,Ppath,PCorrespondences,PBiMixScores,GParams,PRecordGraph,PLabels,PLL)

relSizeTH=1/10; % The relative number of frames of the total number of frames from which to remove clusers


pLabels=PLabels;    
pCorr=PCorrespondences;
pBiMixScores=PBiMixScores;
pSolutions=PSolutions;
pRecordGraph=PRecordGraph;
ppath=Ppath;
pLL=PLL;

[ pLabels,  pRecordGraph ]=prepareUnitedLabels(data,pSolutions,N,ppath,pCorr,GParams);


c=1;

%for i=unique(Labels)
for i=1:100
	R=zeros(1,max(unique(pLabels)));
	
    frames=[];
    cind=1;
    
    % frames(i,1) - the first frame occurence of cluster i, 
    % frames(i,2) - the last frame.
    
    frames=zeros(max(unique(pLabels)),2);
    for j=1:size(N,2)
        count=pLabels(cind:cind+N(j)-1);
        u=unique(count);
        frames(u,1)=frames(u,1)+(frames(u,1)==0)*j;
        s=setdiff(1:size(frames,1),u);
        frames(s,2)=frames(s,2)+((frames(s,1)>0) & (frames(s,2)==0))*j;
        cind=cind+N(j);    
    end
    frames(:,2)=frames(:,2)+(frames(:,2)==0)*(size(N,2)+1);
    frames(:,2)=frames(:,2)-1;
    
    % R(i) = Number of frames cluster i occurs.
    R=frames(:,2)-frames(:,1)+1;
	[S Ind]=sort(R);
    Ind';
    
    %dbstop in post at 38;
    C=Ind(c);
    
	if ((C>1 && S(c)<relSizeTH*size(pLL,1)) || (S(c)==1))
	    [pLabels2 pRecordGraph pSolutions2 pCorr ppath pLL pBiMixScores]=processLabel2(data,pSolutions,N,ppath,pCorr,pBiMixScores,GParams,pRecordGraph,pLabels,pLL,C,frames);
        if (sum(pLabels~=pLabels2)==0 && isequal(pSolutions,pSolutions2)) % they are the same
            c=c+1;
        else
            c=1;
            pLabels=pLabels2;
            pSolutions=pSolutions2;
        end
    else
    if (C==1)
            c=c+1;
        else
            disp(sprintf('Finished after %d rounds',i));
            break;
        end
    end
end