%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    Copyright (C) 2004 Adam Spiro and Aharon Bar-Hillel
%    An implementation of a spike sorting algorithm according to the paper:
%    "Spike Sorting: Bayesian Clustering of Non-Stationary Data" 
%    by Aharon Bar-Hillel, Adam Spiro and Eran Stark 
%    (http://www.cs.huji.ac.il/~aharonbh/papers/SpikeSort_NIPS04.ps)
%
%    This program is free software; you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation; either version 2 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% preprocessEranLabels script : it rearrange the labels of tag ( Eran's labeling)
% and  pos (the on-line labels) so that the labels start from 1, where 1 is
% the  background model.

% rearrange 'tag' : assumes the first model is the background
plg=pilug(tag);
for i=1:size(plg,1);
    inds=find(tag==plg(i,1));
    ttag(inds)=i;
end
tag=ttag;   
clear ttag;

% rearrange pos labels : -1 and 12 are backgound. other are usefull labels.
inds=find(pos==-1 | pos==12);
tpos(inds)=1;
plg=pilug(pos);
for i=1:size(plg,1)
    if plg(i,1)~=-1 & plg(i,1)~=12
        inds=find(pos==plg(i,1));
        tpos(inds)=i;
    end
end
pos=tpos;
clear tpos;
