% approximate new weights - :

% uses caculate_partition_function3 to compute function
% and gradient. Then projects gradient the the subspace where
% sum(alphaGradient)==0, so as to keep the Alphas in the
% simplex. Uses lineSearch to search for a local maxima in the
% gradients 

function  [newAlphas]= approximateWeights2(naiveWeights,EMParams)
% naiveWeights - the  coefficients of the log(a(j)) in the function to be maximized
% and also the initial a(j)

global late_oracle;
global aa_flag;
global anti_chunk_num;
global cEMParams;   % this is a global known also in 'calcY2'. it is needed
% in order to let calcY2 know wether it used version 3 or 4 of 
% calculate_partition_function
cEMParams=EMParams;


meaningfull_Gradient_saf=1e-10;	% gradient stop criteion ( not really important )
meaningful_move_saf=1e-4 ;
global exit_flags;

%initial guess is current weights:
normalizer= sum(naiveWeights);
newAlphas= naiveWeights./normalizer;

% if late oracle , do gradient ascent in two stages : only chunklet pf in the first
% and full pf in the second. if not late oracle , only the second stage is needed.

debug_counter=0;

while 1	% main gradient ascent loop
    %needs checking here - added aa_flag why is grad_flag=0?
    if isempty(EMParams.CW)
        [logPF, GPF ]= calculate_partition_function3(newAlphas,0);
    else
        [logPF, GPF ]= calculate_partition_function4(EMParams,newAlphas,0);
    end
    
    % calculate the Q-function value ( for debuging and stop ascent condition )
    currY=-logPF + naiveWeights*log(newAlphas)';
    
    % the Gradient of the Q-function to maximize. (signed as Y in this context )
    alphaGradient= -GPF' + naiveWeights./newAlphas;
    
    % gradient projection - to remain in simplex!!!
    [gradientY]= computeGradientProjection(alphaGradient);
    
    % check for meaningfull gradient
    if (sum(abs(gradientY))<meaningfull_Gradient_saf)
        break;
    else
        %recieve gradient and function value and perform binary line search.
        
        [nextAlphas nextY ]= lineSearch2(logPF ,naiveWeights,newAlphas,...
            gradientY); 
        
        % check for meaningful change
        if ( (-nextY)-currY )<meaningful_move_saf	 % local maximum 
            break;
        end
        
        % adjust the weights
        newAlphas=nextAlphas;
    end
    debug_counter= debug_counter+1;
    
    if(debug_counter==10)
      break
    end
    
end


